package cz.frantovo.rozsireneAtributy.gui;

import cz.frantovo.rozsireneAtributy.Atribut;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author fiki
 */
public class Panel extends javax.swing.JPanel {

	private static final Logger log = Logger.getLogger(Panel.class.getSimpleName());
	private Model model;
	private Atribut vybranýAtribut;

	public Panel(Model model) {
		this.model = model;
		initComponents();
		tabulka.setModel(model);
		
		/** Výběr aktuálního atributu v tabulce */
		tabulka.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

			public void valueChanged(ListSelectionEvent e) {
				int řádek = tabulka.getSelectedRow();
				if (řádek < 0) {
					vybranýAtribut = null;
					tlačítkoSmazat.setEnabled(false);
				} else {
					vybranýAtribut = getModel().getAtribut(řádek);
					tlačítkoSmazat.setEnabled(true);
				}
			}
		});
	}

	private Model getModel() {
		return model;
	}

	private void zobrazChybovouHlášku(String hláška, Throwable chyba) {
		JOptionPane.showMessageDialog(this, hláška, "Chyba", JOptionPane.ERROR_MESSAGE);
		log.log(Level.WARNING, hláška, chyba);
	}

	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        posuvnýPanel = new javax.swing.JScrollPane();
        tabulka = new javax.swing.JTable();
        tlačítkoPřidat = new javax.swing.JButton();
        tlačítkoSmazat = new javax.swing.JButton();
        tlačítkoZnovuNačíst = new javax.swing.JButton();

        tabulka.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tabulka.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        posuvnýPanel.setViewportView(tabulka);

        tlačítkoPřidat.setMnemonic('p');
        tlačítkoPřidat.setText("Přidat atribut");
        tlačítkoPřidat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tlačítkoPřidatActionPerformed(evt);
            }
        });

        tlačítkoSmazat.setMnemonic('s');
        tlačítkoSmazat.setText("Smazat atribut");
        tlačítkoSmazat.setEnabled(false);
        tlačítkoSmazat.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tlačítkoSmazatActionPerformed(evt);
            }
        });

        tlačítkoZnovuNačíst.setMnemonic('z');
        tlačítkoZnovuNačíst.setText("Znovu načíst");
        tlačítkoZnovuNačíst.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tlačítkoZnovuNačístActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(tlačítkoPřidat)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tlačítkoSmazat)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tlačítkoZnovuNačíst)
                .addContainerGap(186, Short.MAX_VALUE))
            .addComponent(posuvnýPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 543, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(posuvnýPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 277, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tlačítkoPřidat)
                    .addComponent(tlačítkoSmazat)
                    .addComponent(tlačítkoZnovuNačíst))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

	private void tlačítkoPřidatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tlačítkoPřidatActionPerformed
		model.přidejAtribut(new Atribut());
	}//GEN-LAST:event_tlačítkoPřidatActionPerformed

	private void tlačítkoSmazatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tlačítkoSmazatActionPerformed
		try {
			model.odeberAtribut(vybranýAtribut);
		} catch (IOException e) {
			zobrazChybovouHlášku("Nepodařilo se smazat atribut.", e);
		}
	}//GEN-LAST:event_tlačítkoSmazatActionPerformed

	private void tlačítkoZnovuNačístActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tlačítkoZnovuNačístActionPerformed
		try {
			model.načtiAtributy();
		} catch (IOException e) {
			zobrazChybovouHlášku("Nepodařilo se načíst atributy", e);
		}
	}//GEN-LAST:event_tlačítkoZnovuNačístActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane posuvnýPanel;
    private javax.swing.JTable tabulka;
    private javax.swing.JButton tlačítkoPřidat;
    private javax.swing.JButton tlačítkoSmazat;
    private javax.swing.JButton tlačítkoZnovuNačíst;
    // End of variables declaration//GEN-END:variables
}
